Subject: Re: bug#48125: 28.0.50; Display garbled by emoji variation sequence

From: Filipp Gunbin <[email-masked]>
Date: Tue, 04 May 2021 22:06:36 +0300

On 04/05/2021 19:51 +0300, Eli Zaretskii wrote:

>> From: Filipp Gunbin <[email-masked]>
>> Cc: [email-masked]
>> Date: Tue, 04 May 2021 19:20:27 +0300
>>
>> > OK in what sense?  On TTY frames layout and rendering are left to the
>> > terminal emulator; if it can handle this situation, Emacs won't care.
>>
>> The effect of different widths is, of course, different number of chars
>> per line (easily seen in Terminal with emoji or Asian scripts).  Does
>> Emacs make assumptions about number of columns per line?
>
> It does, but the number of columns doesn't change, only the width
> changes.  Right?
>
> What Emacs expects is that the terminal emulator will space characters
> according to the width in columns (either 1 or 2) of each character,
> as defined in the Unicode Character database.  You can see what Emacs
> thinks about the width of each character by using 'char-width'.
> AFAIR, all emoji should have width of 2, is that right?

I see now!

One more question.  In the attached screenshot there're two lines, one
with soccer balls (width 2), and another with letter "a" (width 1).
Both do not fit on screen, and are continued to the next (screen) line.
When at EOL of either, C-x = reports column=142, but the first is longer
(by 1 column).  That is because it's continued with two backslashes, not
one.  Is this the right behavior?